Apache C++ Standard Library Reference Guide

## wcerr

Library: Input/output

- Local Index
- Summary
- Synopsis
- Description
- Formatting
- Example
- See Also
- Standards Conformance

### Local Index

No Entries

### Summary

A predefined stream that controls output to an unbuffered stream buffer associated with the object `stderr` declared in `<cstdio>`

### Synopsis

    #include <iostream>

    namespace std {
      extern wostream wcerr;
    }

### Description

The object `wcerr` controls output to an unbuffered stream buffer associated with the object `stderr` declared in `<cstdio>`. By default the standard C and C++ streams are synchronized, but you can improve performance by using the ios_base member function `synch_with_stdio` to desynchronize them.

`wcerr` uses the locale `codecvt` facet to convert the wide characters it receives to the tiny characters it outputs to `stderr`.

### Formatting

The formatting is done through member functions or manipulators. See cout, wcout, or basic_ostream for details.

### Example

    //
    // wcerr example
    //
    #include <iostream>
    #include <fstream>

    void main ( )
    {
      using namespace std;

      // open the file "file_name.txt"
      // for reading
      wifstream in("file_name.txt");

      // output the all file to stdout
      if ( in )
        wcout << in.rdbuf();
      else
        // if the wifstream object is in a bad state
        // output an error message to stderr
        wcerr << L"Error while opening the file" << endl;
    }

### See Also

basic_ostream, basic_iostream, basic_filebuf, cout, cin, cerr, clog, wcin, wcout, wclog, ios_base, basic_ios

### Standards Conformance

ISO/IEC 14882:1998 -- International Standard for Information Systems --Programming Language C++, Section 27.3.2